package jemu.ui;

/**
 * Title:        JEMU by cpc.devilmarkus.de / jemu.winape.net
 * Description:  JAVA emulator for Amstrad Homecomputers
 * Copyright:    Copyright (c) 2002-2008
 * Company:
 * @author       Devilmarkus
 * @version 4.0
 * 
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import javax.swing.border.*;
import jemu.system.cpc.CPC;

public class Autotype extends WindowAdapter implements WindowListener, ActionListener
{
    protected GridBagConstraints gbcConstraints   = null;
	public static JFrame typeconsole;
        public static String autotext;
	public static JTextArea textArea;
	public JButton button   =new JButton(" Send to emulator"); 
	public JButton button2  =new JButton("  Clear console  ");
	public JButton button3  =new JButton("    Copy text    ");
	public JButton button4  =new JButton("   Paste text    ");

	public Autotype()
	{
		typeconsole=new JFrame("JavaCPC Autotype");
		Dimension screenSize=Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize=new Dimension((int)(screenSize.width/2),(int)(screenSize.height/2));
		int x=(frameSize.width/2 + 110);
		int y=(frameSize.height/2 + 60);
		typeconsole.setBounds(x,y,370,380);
		textArea=new JTextArea();
		textArea.setEditable(true);
                textArea.setAutoscrolls(true);
                textArea.setBackground(Color.WHITE);
                textArea.setForeground(Color.BLACK);
                textArea.setCaretColor(Color.RED);
                textArea.setSelectedTextColor(Color.RED);
                textArea.setSelectionColor(Color.ORANGE);
                textArea.setBorder(new BevelBorder(BevelBorder.LOWERED));
                textArea.setFont(new Font("Courier", 1, 12));
                button.setForeground(Color.LIGHT_GRAY);
                button.setBackground(Color.DARK_GRAY);
                button.setBorder(new BevelBorder(BevelBorder.RAISED));
                button.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));                
                button2.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button2.setForeground(Color.LIGHT_GRAY);
                button2.setBackground(Color.DARK_GRAY);
                button2.setBorder(new BevelBorder(BevelBorder.RAISED));             
                button3.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button3.setForeground(Color.LIGHT_GRAY);
                button3.setBackground(Color.DARK_GRAY);
                button3.setBorder(new BevelBorder(BevelBorder.RAISED));             
                button4.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
                button4.setForeground(Color.LIGHT_GRAY);
                button4.setBackground(Color.DARK_GRAY);
                button4.setBorder(new BevelBorder(BevelBorder.RAISED));
		typeconsole.getContentPane().setLayout(new GridBagLayout());
                typeconsole.add(button,getGridBagConstraints(1, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button2,getGridBagConstraints(2, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button3,getGridBagConstraints(3, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(button4,getGridBagConstraints(4, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                typeconsole.add(new JScrollPane(textArea),getGridBagConstraints(1, 1, 1.0, 1.0, 5, GridBagConstraints.BOTH));

                typeconsole.setAlwaysOnTop(true);
		typeconsole.setVisible(false);	
		typeconsole.addWindowListener(this);		
		button.addActionListener(this);	
                button.setFocusable(false);	
		button2.addActionListener(this);	
                button2.setFocusable(false);
		button3.addActionListener(this);	
                button3.setFocusable(false);
		button4.addActionListener(this);	
                button4.setFocusable(false);
	}
			  private GridBagConstraints getGridBagConstraints(int x, int y, double weightx,double weighty,
            int width, int fill)
                {
                if (this.gbcConstraints == null) {
                    this.gbcConstraints = new GridBagConstraints();
                }
                this.gbcConstraints.gridx = x;
                this.gbcConstraints.gridy = y;
                this.gbcConstraints.weightx = weightx;
                this.gbcConstraints.weighty = weighty;
                this.gbcConstraints.gridwidth = width;
                this.gbcConstraints.fill = fill;
            return this.gbcConstraints;
  }
	public synchronized void windowClosing(WindowEvent evt)
	{
		typeconsole.setVisible(false);
		//typeconsole.dispose();
	}
	
	public synchronized void actionPerformed(ActionEvent evt)
	{
                if (evt.getSource() == button) {
		textArea.selectAll();
                autotext = textArea.getText();
                System.out.println("Autotext is:\n"+autotext);
                CPC.getfromautotype = 1;
                typeconsole.setVisible(false);
                } 
                if (evt.getSource() == button2)
		textArea.setText("");
                if (evt.getSource() == button3){
                if (!textArea.getText().equals("")){
		textArea.selectAll();
                textArea.copy();
                textArea.paste();}
                }
                if (evt.getSource() == button4)
		textArea.paste();
               
                    //textArea.paste();
	}		
}